package com.offcn.api.tk.app3;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.util.HashMap;
import java.util.Map;

import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;



/**
 * 
 * @Description:   27.App推送-校验考试上下架状态和练习册上下架状
 * @author: wff    
 * @date: 2019年6月20日 下午6:59:16   
 * @version V1.0
 */
public class checkPushExam extends TK implements API {
	public String parameter;//参数集合
	
	public String exam_ids;//需要校验的考试id,请按照一定的顺序,逗号隔开传参
	public String practice_id;//需要校验的练习册id,不需校验练习册请不要传此参数



	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		exam_ids = MapUtil.getParameter(parameter, "exam_ids").trim();
		practice_id = MapUtil.getParameter(parameter, "practice_id").trim();
		
		if ((!exam_ids.equals("")) && exam_ids.equals("code")) {
//			record_id = record_id_L;
			exam_ids = L_exam_id;
			parameter = parameter.replace("\"exam_ids\":code", "\"exam_ids\":\""+ exam_ids + "\"");
		}
		if ((!practice_id.equals("")) && practice_id.equals("code")) {
			practice_id = "597";
			parameter = parameter.replace("\"practice_id\":code", "\"practice_id\":\""+ practice_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String, String> headers=new HashMap<String, String>();
		headers.put("Authorization", tk_token);
		
		Map<String, String>  jsonAsMap=new HashMap<String, String>();
		parameter = MapUtil.getValue("parameter", data);
		String tikuString= MapUtil.getParameter(parameter, "appid").trim();
		tikuString = MapUtil.killQuotes(tikuString, "\"");
		
		jsonAsMap.put("exam_ids", exam_ids);
		jsonAsMap.put("practice_id", practice_id);
		jsonAsMap.put("appid", tikuString);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setHeaders(headers);
		myRequest.setRequest(Request);
		myRequest.setFormParameter(jsonAsMap);
		myRequest.setUrl(Url);
		
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("0".equals(code)){
				
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
